{
  vykonna cast knihovny pro nahradu stringu %JMENO% za odpovidajici hodnotu promenne

  Gord, Medwyn
  1.1.0
  1.1.1 - doplnen chybejici zaverecny prevod na ANSI, pokud je to treba
        - opravena chyba u nahrazovani %GGSCRIPTDIR%
        - pridana nova function VarSubstDlgTemplateStringNoSave(caption,id,sTemplate: string) : String;
        - pridana moznost skryt prave vystupni okno, pri kliknuti na tlacitko "prohlizec" je vzdy vyvolan i refresh
        - upravena implementace vkladani vzoru do sablony - uz nedochazi k neprijemnemu scrollovani na zacatek pri pouziti "vlozit" 
        - pridan dotaz, zda chce uzivatel ulozit zmenenou sablonu
        - pripraveno na pripadnou lokalizaci do AJ

//{$DEFINE profile} //Odkomentujte tento radek, pokud chcete prubeh skriptu profilovat

uses VarSubstForm {$IFDEF profile},ProfileUnit{$ENDIF};

const VARSUBST_URL='http://geoget.ararat.cz/doku.php/user:skript:varsubst';
      VARSUBST_ANSI=true;
      VARSUBST_UTF=false;
      VARSUBST_MAXFUNC=100;
      VARSUBST_ISINIT='Yes'; //Definovane jako konstanta kvuli nejasnemu stavu true/false v neinicalizovanem booleanu
      VARSUBST_CRLF='&CRLF&';
      VARSUBST_REGVATA='\s*('+VARSUBST_CRLF+')*\s*';
      VARSUBST_VZOR_SEPARATE=' - ';
type
     VarSubstGeo_TypeFuncReplace=function(geo:TGeo;sTemplate:string): string;
     VarSubstGeo_TypeFuncReplaceArr=array[0..VARSUBST_MAXFUNC] of record
       fFunkce:VarSubstGeo_TypeFuncReplace;
       sVzor:string;
       bBefore:boolean;                  //priznak volani pred nahradou knihovnimi funkcemi
     end;
     VarSubstWpt_TypeFuncReplace=function(wpt:TWpt;sTemplate:string): string;
     VarSubstWpt_TypeFuncReplaceArr=array[0..VARSUBST_MAXFUNC] of record
       fFunkce:VarSubstWpt_TypeFuncReplace;
       sVzor:string;
       bBefore:boolean;                  //priznak volani pred nahradou knihovnimi funkcemi
     end;  
var VarSubst_Geo:TGeo;
    VarSubst_bAnsi:boolean; //priznak vystupu v CP Win1250
    VarSubstGeo_ReplaceFuncArr:VarSubstGeo_TypeFuncReplaceArr;
    VarSubstWpt_ReplaceFuncArr:VarSubstWpt_TypeFuncReplaceArr;
    VarSubstGeo_ReplaceFuncN:Integer;
    VarSubstWpt_ReplaceFuncN:Integer;
    VarSubst_sInit:string;           //priznak provedene inicializace
    VarSubst_sLastDir:string;
    VarSubst_sLastTemplateFile:string;
    VarSubst_bBrowser:boolean;
    VarSubst_sHtml:string;
    VarSubst_sLoadedTemplate:string; //obsah sablony, ktera byla nactena do okna. Pouzito pri porovnavani, zda se soubor zmenil
    VarSubst_bFileOperationsVisible:boolean; //jsou momentalne zobrazeny ovladaci prvky na ukladani?

function VarSubst_DeleteComment(text:string):string;
begin
  //neumim napsat spravny reg prikaz, zadny nepracuje spravne kdyz je vice
  //komentaru za sebou, komentarovy radek na zacatku nebo na konci (zustavaji
  //radky nebo jen CRLF
  Result:=RegexReplace('(?m)(^|\r\n)(\s*#.*?)(\r\n|$)',text,'$1',true);
end;

procedure VarSubst_SetCombo;
begin
  VarSubstForm_ComboSeznam.Text:='';
  VarSubstForm_ComboSeznam.Items.Add(_('------ Globln promnn ------'));
  VarSubstForm_ComboSeznam.Items.Add('%GGDATADIR% - ' + _('datov adres GeoGetu'));
  VarSubstForm_ComboSeznam.Items.Add('%GGSCRIPTDIR% - ' + _('adres GeoGetu, v kterm jsou oekvny scripty'));
  VarSubstForm_ComboSeznam.Items.Add('%GGDBNAME% - ' + _('jmno databze GeoGetu'));
  VarSubstForm_ComboSeznam.Items.Add('%GGVER% - ' + _('verze GeoGetu'));
  VarSubstForm_ComboSeznam.Items.Add('%GGOWNER% - ' + _('uivatel GeoGetu'));
  VarSubstForm_ComboSeznam.Items.Add('%CRLF% - ' + _('oddkovn'));
  VarSubstForm_ComboSeznam.Items.Add('');
  VarSubstForm_ComboSeznam.Items.Add(_('------ Globln funkce ------'));
  VarSubstForm_ComboSeznam.Items.Add('%TAG("kategorie")% - ' + _('nhrada hodnotami TAGu zadan kategorie'));
  VarSubstForm_ComboSeznam.Items.Add('%IFTAG("kategorie"; "hodnota"; "txt-true"; "txt-false")% - ' + _('nhrada textem podle toho, zda bod m nastaven TAG pslun kategorie a hodnoty nebo nem'));
  VarSubstForm_ComboSeznam.Items.Add('%IF("str1" oper "str2"; "txt-true"; "txt-false")% - ' + _('nhrada textem podle platnosti zadan podmnky. Funkce test vyhodnocuje porovnnm string s ohledem na velikost psmen.'));
  VarSubstForm_ComboSeznam.Items.Add('%ROT13("str")% - ' + _('zakduje vstupn string zpsobem obvyklm pi kdovn hintu'));
  VarSubstForm_ComboSeznam.Items.Add('%REVERSE("str")% - ' + _('obrt poad znak ve stringu'));
  VarSubstForm_ComboSeznam.Items.Add('%REPLACE("str","vzor","nhrada")% - ' + _('nhrada textu jinm'));
  VarSubstForm_ComboSeznam.Items.Add('%REPLACEFULL("str","vzor","nhrada")% - ' + _('nhrada textu jinm (na konci zpracovn)'));
  VarSubstForm_ComboSeznam.Items.Add('');
  VarSubstForm_ComboSeznam.Items.Add(_('------ Funkce a promnn pro Cache ------'));
  VarSubstForm_ComboSeznam.Items.Add('%NAME% - ' + _('jmno bodu'));
  VarSubstForm_ComboSeznam.Items.Add('%FAMILY% - ' + _('typ bodu (prvn 2 znaky: GC, WM, )'));
  VarSubstForm_ComboSeznam.Items.Add('%ID% - ' + _('identifiktor bodu (GC12345)'));
  VarSubstForm_ComboSeznam.Items.Add('%GUID% - ' + _('pln identifiktor bodu pouvan v URL na geocaching.com'));
  VarSubstForm_ComboSeznam.Items.Add('%AUTHOR% - ' + _('autor (vlastnk) bodu'));
  VarSubstForm_ComboSeznam.Items.Add('%TYPE% - ' + _('typ bodu (Traditional, Multi cache, Letterbox hybrid, )'));
  VarSubstForm_ComboSeznam.Items.Add('%TYPEID% - ' + _('jeden znak identifikace typu (T=traditional, M=multi, )'));
  VarSubstForm_ComboSeznam.Items.Add('%SIZE% - ' + _('velikost (Micro, )'));
  VarSubstForm_ComboSeznam.Items.Add('%SIZEID% - ' + _('jeden znak velikost (M=mikro, S=small, '));
  VarSubstForm_ComboSeznam.Items.Add('%DIFFICULTY% - ' + _('obtnost (1  5)'));
  VarSubstForm_ComboSeznam.Items.Add('%DIFFID% - ' + _('jeden znak obtnosti (1,A,2,B,3,C,4,D,5)'));
  VarSubstForm_ComboSeznam.Items.Add('%TERRAIN% - ' + _('tern (1  5)'));
  VarSubstForm_ComboSeznam.Items.Add('%TERRID% - ' + _('jeden znak ternu (1,A,2,B,3,C,4,D,5)'));
  VarSubstForm_ComboSeznam.Items.Add('%IDTAG% - ' + _('zkrcen informace (TM2B)'));
  VarSubstForm_ComboSeznam.Items.Add('%HINT% - ' + _('text npovdy (dekdovan)'));
  VarSubstForm_ComboSeznam.Items.Add('%HIDDEN% - ' + _('datum vytvoen bodu ve tvaru DD.MM.RRRR'));
  VarSubstForm_ComboSeznam.Items.Add('%COORDINATE% - ' + _('souadnice bodu ve tvaru N SSMM.mmm E SSSMM.mmm'));
  VarSubstForm_ComboSeznam.Items.Add('%CORRECTEDCOORDINATE% - ' + _('korigovan souadnice bodu (=finlka)'));
  VarSubstForm_ComboSeznam.Items.Add('%LAT% - ' + _('zempisn dlka ve tvaru SS,dddddd'));
  VarSubstForm_ComboSeznam.Items.Add('%LON% - ' + _('zempisn ka ve tvaru SSS,dddddd'));
  VarSubstForm_ComboSeznam.Items.Add('%LATCORRECTED% - ' + _('dlka souadnice finlky ve tvaru SS,dddddd'));
  VarSubstForm_ComboSeznam.Items.Add('%LONCORRECTED% - ' + _('ka souadnice finlky ve tvaru SSS,dddddd'));
  VarSubstForm_ComboSeznam.Items.Add('%COUNTRY% - ' + _('stt, v kterm bod le (kam pat)'));
  VarSubstForm_ComboSeznam.Items.Add('%STATE% - ' + _('kraj (kanton, ), v kterm bod le (kam pat)'));
  VarSubstForm_ComboSeznam.Items.Add('%STATUS% - ' + _('stav bodu (slice 0,1,2)'));
  VarSubstForm_ComboSeznam.Items.Add('%STATUSTXT% - ' + _('stav bodu textov (Disabled, Archived, )'));
  VarSubstForm_ComboSeznam.Items.Add('%UPDATED% - ' + _('datum posledn aktualizace bodu v DB ve tvaru DD.MM.RRRR'));
  VarSubstForm_ComboSeznam.Items.Add('%LISTING% - ' + _('cel listing bodu'));
  VarSubstForm_ComboSeznam.Items.Add('%LONGLISTING% - ' + _('dlouh popis bodu'));
  VarSubstForm_ComboSeznam.Items.Add('%SHORTLISTING% - ' + _('krtk popis bodu'));
  VarSubstForm_ComboSeznam.Items.Add('%COMMENT% - ' + _('text uivatelskho komente (poznmky)'));
  VarSubstForm_ComboSeznam.Items.Add('%FOUND% - ' + _('datum a as nlezu ve tvaru DD.MM.RRRR HH.MM'));
  VarSubstForm_ComboSeznam.Items.Add('%LASTFOUND% - ' + _('datum poslednho nlezu ve tvaru DD.MM.RRRR'));
  VarSubstForm_ComboSeznam.Items.Add('%PQCACHEID% - ' + _('ID bodu podle PQ'));
  VarSubstForm_ComboSeznam.Items.Add('%PQOWNERID% - ' + _('ID vlastnka podle PQ'));
  VarSubstForm_ComboSeznam.Items.Add('%ATTACHMENTDIR% - ' + _('adres pro plohy'));
  VarSubstForm_ComboSeznam.Items.Add('%RTFATTACHMENTFILE% - ' + _('jmno pipojenho RTF souboru'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTPREFIXID% - ' + _('prefix bodu'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTDESCRIPTION% ' + _('popis bodu'));
  VarSubstForm_ComboSeznam.Items.Add('');
  VarSubstForm_ComboSeznam.Items.Add(_('------ Logick funkce pro kee ------'));
  VarSubstForm_ComboSeznam.Items.Add('%HAVEFINAL% - ' + _('true, pokud m ke finlku'));
  VarSubstForm_ComboSeznam.Items.Add('%ISDISABLED% - ' + _('true, pokud m bod status Disabled'));
  VarSubstForm_ComboSeznam.Items.Add('%ISENABLED% - ' + _('true, pokud m bod status Enabled'));
  VarSubstForm_ComboSeznam.Items.Add('%ISARCHIVED% - ' + _('true, pokud m bod status Archived'));
  VarSubstForm_ComboSeznam.Items.Add('%ISFOUND% - ' + _('true, pokud m bod nenulov datum nlezu'));
  VarSubstForm_ComboSeznam.Items.Add('%ISOWNER% - ' + _('true, pokud bod pat uivateli Geogetu'));
  VarSubstForm_ComboSeznam.Items.Add('%HAVELISTING% - ' + _('true, pokud m bod neprzdn popis'));
  VarSubstForm_ComboSeznam.Items.Add('%HAVEATTACHMENT% - ' + _('true, pokud m bod njak piloen soubor'));
  VarSubstForm_ComboSeznam.Items.Add('%HAVERTFATTACHMENT% - ' + _('true, pokud m bod njak piloen *.rtf soubor'));
  VarSubstForm_ComboSeznam.Items.Add('');
  VarSubstForm_ComboSeznam.Items.Add(_('------ Funkce a promnn pro Wpt ------'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTNAME% - ' + _('jmno bodu'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTID% - ' + _('identifiktor bodu (GC12345)'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTGUID% - ' + _('pln identifiktor bodu pouvan v URL na geocaching.com'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTTYPE% - ' + _('typ bodu)'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTTYPEID% - ' + _('jeden znak identifikace typu (F=Final, P=Parking, Q=Question and answer, '));
  VarSubstForm_ComboSeznam.Items.Add('%WPTCOORDINATE% - ' + _('souadnice bodu ve tvaru N SSMM.mmm E SSSMM.mmm'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTLAT% - ' + _('zempisn dlka ve tvaru SS,dddddd'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTLON% - ' + _('zempisn ka ve tvaru SSS,dddddd'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTUPDATED% - ' + _('datum posledn aktualizace bodu v DB ve tvaru DD.MM.RRRR'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTCOMMENT% - ' + _('text uivatelskho komente (poznmky)'));
  VarSubstForm_ComboSeznam.Items.Add('');
  VarSubstForm_ComboSeznam.Items.Add(_('------ Logick funkce pro Wpt ------'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTISUSERWAYPOINT% - ' + _('true, pokud byl WPT vytvoen i upraven uivatelem'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTISFINAL% - ' + _('true, pokud se jedn o bod s finlovmi souadnicemi'));
  VarSubstForm_ComboSeznam.Items.Add('%WPTISEMPTYCOORD% - ' + _('true, pokud souadnce bodu jsou nulov'));
  VarSubstForm_ComboSeznam.Items.Add('');
  VarSubstForm_ComboSeznam.Items.Add(_('------ Uivatelsk funkce ------'));
end;

procedure VarSubst_Init; //inicializace
var i:Integer;
begin
  {$IFDEF profile} ProfileStart('VarSubst_Init'); {$ENDIF}
  //pole pro ukladani uzivatelskych replace funkci - geo
  for i:=0 to VARSUBST_MAXFUNC do begin
    VarSubstGeo_ReplaceFuncArr[i].fFunkce:=nil;
    VarSubstGeo_ReplaceFuncArr[i].bBefore:=false;
  end;
  VarSubstGeo_ReplaceFuncN:=0;
  
  //pole pro ukladani uzivatelskych replace funkci - wpt
  for i:=0 to VARSUBST_MAXFUNC do begin
    VarSubstWpt_ReplaceFuncArr[i].fFunkce:=nil;
    VarSubstWpt_ReplaceFuncArr[i].bBefore:=false;
  end;
  VarSubstWpt_ReplaceFuncN:=0;
  VarSubst_sInit:=VARSUBST_ISINIT;
  VarSubst_SetCombo();
  VarSubst_bBrowser:=false;
  VarSubst_sHtml:=GEOGET_DATADIR+'\temp\';
  ForceDirectories(VarSubst_sHtml);
  VarSubst_sHtml := VarSubst_sHtml + 'VarSubst_tmp.html';
  VarSubst_sLoadedTemplate := '';
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

procedure VarSubst_WriteHtml;
begin
  {$IFDEF profile} ProfileStart('VarSubst_WriteHtml'); {$ENDIF}
  StringToFile(VarSubstForm_EditResult.Text,VarSubst_sHtml);
  VarSubst_bBrowser:=true;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

procedure VarSubst_LoadTemplateToWindow(content : String);
begin
   VarSubstForm_EditTemplate.Text := content;
   VarSubst_sLoadedTemplate := VarSubstForm_EditTemplate.Text;
end;

function VarSubst_WasTemplateChanged : boolean;
begin
   Result := (VarSubstForm_EditTemplate.Text <> VarSubst_sLoadedTemplate);  
end;

function VarSubstEncode(str:string):string; //zakoduje nebezpecne znaky
//!!!!! nesmi byt volana na celou sablonu kvuli uvozovkam, zrusi to parsovani funkci !!!!!!
//!!!!! slouzi jen k nahrade nebezpecnych znaku v nahrazovanych polozkach            !!!!!!
begin
  //% se nahrazuje az pred volanim funkci %JMENO(...)%, aby nedoslo
  //k nahrade v mistech, kde to nepotrebujeme
  //uvozovky nenahrazovat, indikuji textove parametry funkci
  {$IFDEF profile} ProfileStart('VarSubstEncode'); {$ENDIF}
  Result:=ReplaceString(str,'"','&uvozovky&');
  Result:=ReplaceString(Result,CRLF,VARSUBST_CRLF);
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_Decode(str:string):string; //dekoduje nebezpecne znaky
begin
  {$IFDEF profile} ProfileStart('VarSubst_Decode'); {$ENDIF}
  Result:=ReplaceString(str,'&uvozovky&','"');
  //Result:=ReplaceString(Result,'&perc;','%');
  Result:=ReplaceString(Result,VARSUBST_CRLF,CRLF);
  Result:=ReplaceString(Result,'&end&','');
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_DateToStr(dat:TDateTime):string;   //vystup DD.MM.YYYY
var s:string;
begin
  //if(dat=0) then Result:='00.00.0000'
  {$IFDEF profile} ProfileStart('VarSubst_DateToStr'); {$ENDIF}
  if(dat=0) then Result:=''
  else begin
    s:=DateToInt(dat);
    Result:=copy(s,7,2)+'.'+copy(s,5,2)+'.'+copy(s,1,4);
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_TimeToStr(t:TDateTime):string; //vystup DD.MM.YYYY HH:MM
begin
  {$IFDEF profile} ProfileStart('VarSubst_TimeToStr'); {$ENDIF}
  Result:=FormatDateTime('hh:nn',t);
  if(Result='00:00') then Result:='';
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_StrCmp(str1,oper,str2:string; var err:integer):boolean;
begin
  {$IFDEF profile} ProfileStart('VarSubst_StrCmp'); {$ENDIF}
  err:=0;
  Result:=false;
  //vyhodime pripadne uvozovky
  str1:=ReplaceString(str1,'"','');
  str2:=ReplaceString(str2,'"','');
  oper:=Trim(oper);
  if(oper='>') then begin if(str1>str2) then Result:=true; end
  else if(oper='=') then begin if(str1=str2) then Result:=true; end
  else if(oper='<') then begin if(str1<str2) then Result:=true; end
  else if(oper='<>') then begin if(str1<>str2) then Result:=true; end
  else if(oper='>=') then begin if(str1>=str2) then Result:=true; end
  else if(oper='<=') then begin if(str1<=str2) then Result:=true; end
  else err:=3;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_NumCmp(str1,oper,str2:string;var err:integer):boolean;
var num1,num2:extended;   //err=1 ... chybny znak na vstupu string1
begin                     //    2 ... chybny znak na vstupu string2
  err:=0;                 //    3 ... chybny operator porovnani
  Result:=false;
  {$IFDEF profile} ProfileStart('VarSubst_NumCmp'); {$ENDIF}
  //showMessage('NumCmp: str1="'+str1+'", oper="'+oper+'", str2="'+str2+'"');
  //otestujeme, zda jsou tam jen cislice, pismena, +- a tecka
  if(RegexExtract('[^,.+\-0-9]*',str1)<>'') then err:=1
  else if(RegexExtract('[^,.+\-0-9]*',str2)<>'') then err:=2
  else begin
    //pokud je string prazdny, nahradime jej 0
    //if(str1='') then str1:='0';
    //if(str2='') then str2:='0';
    //nahradime pripadnou desetinnou carku desetinnou teckou a prevedeme na cislo
    num1:=StrToFloat(Trim(ReplaceString(str1,',','.')));
    num2:=StrToFloat(Trim(ReplaceString(str2,',','.')));
    if(oper='>') then begin if(num1>num2) then Result:=true; end
    else if(oper='=') then begin if(num1=num2) then Result:=true; end
    else if(oper='<') then begin if(num1<num2) then Result:=true; end
    else if(oper='<>') then begin if(num1<>num2) then Result:=true; end
    else if(oper='>=') then begin if(num1>=num2) then Result:=true; end
    else if(oper='<=') then begin if(num1<=num2) then Result:=true; end
    else err:=3;
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_FUNCTIONS_1PAR(str,func:string; var err:integer):string;
var par:TStrings; //err=0 nahrazeno, -1 neni co nahradit, 1=neznama funkce 'func'
    s:string;
    //s1:string; num:Integer;
begin
  {$IFDEF profile} ProfileStart('VarSubst_FUNCTIONS_1PAR'); {$ENDIF}
  err:=-1;
  Result:=str;
  par:=TStringList.Create();
  s:=RegexSubstitute('(.*)'+ReplaceString(func,'(','\(')+VARSUBST_REGVATA    //$1=pocatek
    +'"(.*?)"'+VARSUBST_REGVATA+'\)%'                   //$3=val1
    +'(.*)$'                                            //$5=konec
    ,str
    ,'$1'+CRLF+'$3'+CRLF+'$5'
    );
  while(s<>'') do par.Add(fetchbin(s,CRLF)); //prevedeme na strings
  //for num:=0 to par.Count-1 do begin s1:=s1+CRLF+'par['+IntToStr(num)+']='+par[num]; end;
  //showMessage('RRRRR_1PAR parametry:'+s1);
  if(par.Count=3) then begin
    err:=0;
    if(func='%ROT13(') then Result:=par[0]+Rot13(par[1])+par[2]
    else if(func='%REVERSE(') then Result:=par[0]+Reverse(par[1])+par[2]
    else err:=1;
  end;
  par.Free;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_FUNCTIONS_3PAR(str,func:string; var err:integer):string;
var par:TStrings;  //err=0 nahrazeno, -1 neni co nahradit, 1=neznama funkce 'func'
    s:string;
    s1:string; num:Integer;
begin
  {$IFDEF profile} ProfileStart('VarSubst_FUNCTIONS_3PAR'); {$ENDIF}
  err:=-1;
  Result:=str;
  par:=TStringList.Create();
  s:=RegexSubstitute('(.*)'+ReplaceString(func,'(','\(')+VARSUBST_REGVATA  //$1=pocatek
    +'"(.*?)"'+VARSUBST_REGVATA+';'+VARSUBST_REGVATA    //$3=str
    +'"(.*?)"'+VARSUBST_REGVATA+';'+VARSUBST_REGVATA    //$6=vzor
    +'"(.*?)"'+VARSUBST_REGVATA                         //$9=nahrada
    +'\)%(.*)$'                                         //$11=konec
    ,str
    ,'$1'+CRLF+'$3'+CRLF+'$6'+CRLF+'$9'+CRLF+'$11'
    );
  //showMessage('YYYY_3PAR reg.vyraz:'+s1);
  while(s<>'') do par.Add(fetchbin(s,CRLF)); //prevedeme na strings
  for num:=0 to par.Count-1 do begin s1:=s1+CRLF+'par['+IntToStr(num)+']='+par[num]; end;
  //showMessage('YYYY_3PAR str:'+str+CRLF+'funkce: '+func+CRLF+'#parametru='+IntToStr(par.count)+CRLF+'parametry:'+s1);
  if(par.Count=5) then begin
    err:=0;
    if(func='%REPLACE(') then Result:=par[0]+ReplaceString(par[1],par[2],par[3])+par[4]
    else if(func='%REPLACEFULL(') then Result:=par[0]+ReplaceString(par[1],par[2],par[3])+par[4]
    else err:=1;
  end;
  par.Free;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_TAG(str:string;var err:integer):string;
var vzory,vzor,cat:string;
begin     // %TAG("category")%  nahradi hodnotou tagu kese
          // err vraci 0 - nedoslo k nahrade
          //           1 - doslo k nahrade
          //          -1 - chyba "formulace"
  {$IFDEF profile} ProfileStart('VarSubst_TAG'); {$ENDIF}
  err:=0;
  vzory:=RegexExtract('%TAG\(.*?\)%',Result); //nacist pozadavek na kategorii tagu
  while(vzory<>'') do begin
    vzor:=Trim(fetchbin(vzory,CRLF));
    cat:=ReplaceString(RegexExtract('".*"',vzor),'"','');
    if(cat='') then begin
      Result:=ReplaceString(str,vzor,_('ERR: Chyb kategorie tagu v definici.'));
      err:=-1;
    end
    else Result:=ReplaceString(Result,vzor,ReplaceString(VarSubst_Geo.TagValues(cat),CRLF,', '));
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_Unquote(str:string):string;
begin
  {$IFDEF profile} ProfileStart('VarSubst_Unquote'); {$ENDIF}
  Result:=RegexReplace('^"',str,'',true);           //uvodni uvozovky
  Result:=RegexReplace('\s*;$',Result,'',true);     //koncovy strednik
  Result:=RegexReplace('\s*\)$',Result,'',true);    //koncova zavorka
  Result:=RegexReplace('\"$',Result,'',true);       //koncove uvozovky
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_IFTAG(str:string;var err:integer):string;
var vzor,vzory,s1,cat,val1,out_true,out_false:string;
var b : boolean;
begin    // %IFTAG("category";"val1";"out_plati";"out_plati")%
  {$IFDEF profile} ProfileStart('VarSubst_IFTAG'); {$ENDIF}
  Result:=ReplaceString(str,CRLF,VARSUBST_CRLF); //kdyby nahodou byly vlozeny radky
  err:=0;
  vzory:=RegexExtract('%IFTAG\(.*?\)%',Result); //nacist pozadavek
  //ShowMessage('vzory='+vzory);
  while(vzory<>'') do begin
    vzor:=fetchbin(vzory,CRLF);
    s1:=RegexExtract('".*?"\s*[;\)]',vzor); //vrati polozky oddelene CRLF
    //ShowMessage('vzor='+vzor);
    cat:=VarSubst_Unquote(Trim(fetchbin(s1,CRLF)));
    val1:=VarSubst_Unquote(Trim(fetchbin(s1,CRLF)));
    out_true:=VarSubst_Unquote(Trim(fetchbin(s1,CRLF)));
    out_false:=VarSubst_Unquote(Trim(fetchbin(s1,CRLF)));
    //ShowMessage('vzor='+vzor);
    //ShowMessage('cat='+cat+CRLF+'val1='+val1+CRLF+
    //         'out_true='+out_true+CRLF+'out_false='+out_false);
    //pokud je text v ANSI, prevedeme jej do UTF8
    if(VarSubst_bAnsi) then begin
      cat:=AnsiToUtf(cat);
      val1:=AnsiToUtf(val1);
    end;
    if(err<>0) then ReplaceString(str,vzor,_('ERR: Chyb oddlova (stednk) (txt_true,txt_false).'))
    else begin
      //dotazem do databaze zjistime, zda TAG existuje
      //pokud je val1='', pak je to dotaz na jakoukoli hodnotu v teto kategori
      if(val1='') 
        then b := VarSubst_Geo.TagHaveCategory(cat)
        else b := pos(val1, VarSubst_Geo.TagValues(cat)) > 0;                                                        
      if b 
        then Result:=ReplaceString(Result,vzor,out_true)
        else Result:=ReplaceString(Result,vzor,out_false);   
    end;
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_IF(str:string;var err:integer):string;
                       //err:  -1 OK funkce IF neni pouzita
                       //       0 OK, nahrazeno
                       //       1 chyba v parametru 1
                       //       2 chyba v parametru 2
                       //       3 chybny operator porovnani
                       //       4 chybny pocet parametru funkce IF
var par:TStrings;
    s:string;
    num:integer;
    //VATA:string;
begin    //%IF("str1">"str2";"out_plati";"out_neplati")%
         //%IF(val1>val2;"out_plati";"out_neplati")%
         //mozne operatory: > < >= <= =
  //VATA:='';//'(&CRLF&)*\s*';
  //VATA:='\s*(&CRLF&)*\s*';
  {$IFDEF profile} ProfileStart('VarSubst_IF'); {$ENDIF}
  err:=-1;
  par:=TStringList.Create();
  s:=RegexSubstitute({'(.*)%IF\('+}VARSUBST_REGVATA     //$1=vata
    +'(".*?")'+VARSUBST_REGVATA                         //$2=val1
    +'([<>=]{1,2})'+VARSUBST_REGVATA                    //$4=oper
    +'(".*?")'+VARSUBST_REGVATA+';'+VARSUBST_REGVATA    //$6=va2
    +'"(.*?)"'+VARSUBST_REGVATA+';'+VARSUBST_REGVATA    //$9=trueText
    +'"(.*?)"'+VARSUBST_REGVATA+'\)%'                   //$12=falseText
    +'(.*)'                                             //$14=konec
    ,str
    //0=val1  1=oper    2=val2    3=true    4=false     5=zbytek
    ,'$2'+CRLF+'$4'+CRLF+'$6'+CRLF+'$9'+CRLF+'$12'+CRLF+'$14'
    //,'$1'+CRLF+'$2'+CRLF+'$3'+CRLF+'$4'+CRLF+'$5'+CRLF+'$6'+CRLF+'$7'
    // +'$8'+CRLF+'$9'+CRLF+'$10'+CRLF+'$11'+CRLF+'$12'+CRLF+'$13'+CRLF+'$14'+CRLF+'$15'
    );
  while(s<>'') do par.Add(fetchbin(s,CRLF)); //prevedeme na strings
  //for num:=0 to par.Count-1 do begin s1:=s1+CRLF+'par['+IntToStr(num)+']='+par[num]; end;
  //ShowMessage('HHHHHH-2 pocet parametru='+IntToStr(par.Count)+CRLF+s1);
  //pokud vstupni string nema za koncovym % zadny znak (ani CRLF), regularni knihovna
  //chybne vraci jen 13 promennych, proto si ten konec umele pridam
  if(par.Count=5) then par.Add('');
  if(par.Count=6) then begin
    err:=0;
    //tim mame v poli par rovnou posledni IF v stringu rozlozeny na parametry a muzeme s nimi pracovat
    if((copy(par[0],1,1)<>'"') and (par[0]<>'')) then num:=1;
    if((copy(par[2],1,1)<>'"') and (par[2]<>'')) then num:=num+1;
    s:='';
    if(num=2) then begin if(VarSubst_NumCmp(par[0],par[1],par[2],err)) then s:='y'; end
    else begin if(VarSubst_StrCmp(par[0],par[1],par[2],err)) then s:='y'; end;
    if(err=0) then begin    //zkonstruujeme vysledek
      if(s='y') then Result:=par[3]+par[5]
      else           Result:=par[4]+par[5];
    end;
  end
  else if(par.Count<>0) then err:=4;
  //ShowMessage('WWWWW vysledek:'+Result);
  par.Free();
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_RecurseFunc(str,func:string):string;
var par:TStrings;
    s:string;
    num,stop,err:integer;
begin
  {$IFDEF profile} ProfileStart('VarSubst_RecurseFunc'); {$ENDIF}
  Result:='';
  par:=TStringList.Create();
  //rozdelime string na funkce (pred zavorku zpetne lomitko, aby nebylo brano za regularni znak skupiny)
  s:=RegexSplit(ReplaceString(func,'(','\('),str);
  //ShowMessage(s);
  while(s<>'') do par.Add(fetchbin(s,CRLF)); //prevedeme na strings
  //ShowMessage('KKKKK pocet '+func+': '+IntToStr(par.Count));
  //kterym prvkem koncime?
  num:=pos(func,str);
  if(num>=1) then stop:=1 //preskocime prvni parametr, je to budto zacatek nebo prazdny string (pokud byla funkce na zacatku)
  else begin stop:=2; Result:=str; end;  //nevyskytuje se vubec, nechame beze zmeny
  //ShowMessage('str='+str+CRLF+'func='+func+CRLF+'num='+IntToStr(num)+CRLF+'stop='+IntToStr(stop)+CRLF+'#par='+IntToStr(par.Count));
  if(stop<2) then begin
    for num:=par.Count-1 downto stop do begin
      if(func='%IF(') then Result:=VarSubst_IF(par[num]+Result,err);
      if(func='%REPLACEFULL(') then Result:=VarSubst_FUNCTIONS_3PAR(func+par[num]+Result,func,err);
      if(func='%REPLACE(') then Result:=VarSubst_FUNCTIONS_3PAR(func+par[num]+Result,func,err);
    end;
    //ShowMessage('QQQQQ prvni vyskyt "'+func+'" na pozici: '+IntToStr(pos(func,str)));
    if(par[0]<>'') then Result:=par[0]+Result; //pridat cast pred prvnim vyskytem funkce
  end;
  par.Free;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstGeo_SUBSTITUTIONS(geo:TGeo;str:string) : String;
begin
  {$IFDEF profile} ProfileStart('VarSubstGeo_SUBSTITUTIONS'); {$ENDIF}
  Result := str;
  //Jednoduche nahrazeni
  if(pos('%NAME%',Result)>0) then                 Result:=ReplaceString(Result,'%NAME%',VarSubstEncode(geo.Name));
  if(pos('%FAMILY%',Result)>0) then               Result:=ReplaceString(Result,'%FAMILY%',geo.Family());
  if(pos('%ID%',Result)>0) then                   Result:=ReplaceString(Result,'%ID%',geo.ID);
  if(pos('%GUID%',Result)>0) then                 Result:=ReplaceString(Result,'%GUID%',geo.GUID);
  if(pos('%AUTHOR%',Result)>0) then               Result:=ReplaceString(Result,'%AUTHOR%',geo.Author);
  if(pos('%TYPE%',Result)>0) then                 Result:=ReplaceString(Result,'%TYPE%',geo.CacheType);
  if(pos('%TYPEID%',Result)>0) then               Result:=ReplaceString(Result,'%TYPEID%',geo.TypeID);
  if(pos('%SIZE%',Result)>0) then                 Result:=ReplaceString(Result,'%SIZE%',geo.Size);
  if(pos('%SIZEID%',Result)>0) then               Result:=ReplaceString(Result,'%SIZEID%',geo.SizeID);
  if(pos('%DIFFICULTY%',Result)>0) then           Result:=ReplaceString(Result,'%DIFFICULTY%',geo.Difficulty);
  if(pos('%DIFFID%',Result)>0) then               Result:=ReplaceString(Result,'%DIFFID%',geo.DiffID);
  if(pos('%TERRAIN%',Result)>0) then              Result:=ReplaceString(Result,'%TERRAIN%',geo.Terrain);
  if(pos('%TERRID%',Result)>0) then               Result:=ReplaceString(Result,'%TERRID%',geo.TerrID);
  if(pos('%IDTAG%',Result)>0) then                Result:=ReplaceString(Result,'%IDTAG%',geo.IDTag);
  if(pos('%HINT%',Result)>0) then                 Result:=ReplaceString(Result,'%HINT%',VarSubstEncode(geo.Hint));
  if(pos('%HIDDEN%',Result)>0) then               Result:=ReplaceString(Result,'%HIDDEN%',VarSubst_DateToStr(geo.Hidden));
  if(pos('%COORDINATE%',Result)>0) then           Result:=ReplaceString(Result,'%COORDINATE%',FormatCoordNum(geo.LatNum,geo.LonNum));
  if(pos('%CORRECTEDCOORDINATE%',Result)>0) then  Result:=ReplaceString(Result,'%CORRECTEDCOORDINATE%',FormatCoordNum(geo.CorrectedLatNum,geo.CorrectedLonNum));
  if(pos('%LAT%',Result)>0) then                  Result:=ReplaceString(Result,'%LAT%',geo.Lat);
  if(pos('%LON%',Result)>0) then                  Result:=ReplaceString(Result,'%LON%',geo.Lon);
  if(pos('%LATCORRECTED%',Result)>0) then         Result:=ReplaceString(Result,'%LATCORRECTED%',geo.CorrectedLat);
  if(pos('%LONCORRECTED%',Result)>0) then         Result:=ReplaceString(Result,'%LONCORRECTED%',geo.CorrectedLon);
  if(pos('%COUNTRY%',Result)>0) then              Result:=ReplaceString(Result,'%COUNTRY%',geo.Country);
  if(pos('%STATE%',Result)>0) then                Result:=ReplaceString(Result,'%STATE%',geo.State);
  if(pos('%STATUS%',Result)>0) then               Result:=ReplaceString(Result,'%STATUS%',IntToStr(geo.CacheStatus));
  if(pos('%STATUSTXT%',Result)>0) then            Result:=ReplaceString(Result,'%STATUSTXT%',geo.StatusName);
  if(pos('%UPDATED%',Result)>0) then              Result:=ReplaceString(Result,'%UPDATED%',VarSubst_DateToStr(geo.Updated));
  if(pos('%COMMENT%',Result)>0) then              Result:=ReplaceString(Result,'%COMMENT%',VarSubstEncode(geo.Comment));
  if(pos('%FOUND%',Result)>0) then                Result:=ReplaceString(Result,'%FOUND%',VarSubst_DateToStr(geo.Found)+' '+VarSubst_TimeToStr(geo.FoundTime));
  if(pos('%LASTFOUND%',Result)>0) then            Result:=ReplaceString(Result,'%LASTFOUND%',VarSubst_DateToStr(geo.LastFound));
  if(pos('%PQCACHEID%',Result)>0) then            Result:=ReplaceString(Result,'%PQCACHEID%',geo.CacheID);
  if(pos('%PQOWNERID%',Result)>0) then            Result:=ReplaceString(Result,'%PQOWNERID%',geo.OwnerID);
  if(pos('%ATTACHMENTDIR%',Result)>0) then        Result:=ReplaceString(Result,'%ATTACHMENTDIR%',VarSubstEncode(geo.AttachmentDir));
  if(pos('%RTFATTACHMENTFILE%',Result)>0) then    Result:=ReplaceString(Result,'%RTFATTACHMENTFILE%',VarSubstEncode(geo.RTFAttachmentFile));

  //Logicke funkce
  if(pos('%ISDISABLED%',Result)>0) then begin
    if(geo.IsDisabled) then Result:=ReplaceString(Result,'%ISDISABLED%','true')
    else                    Result:=ReplaceString(Result,'%ISDISABLED%','false');
  end;
  if(pos('%ISENABLED%',Result)>0) then begin
    if((not geo.IsDisabled) and (not geo.IsArchived)) then Result:=ReplaceString(Result,'%ISENABLED%','true')
    else                        Result:=ReplaceString(Result,'%ISENABLED%','false');
  end;
  if(pos('%ISARCHIVED%',Result)>0) then begin
    if(geo.IsArchived) then Result:=ReplaceString(Result,'%ISARCHIVED%','true')
    else                    Result:=ReplaceString(Result,'%ISARCHIVED%','false');
  end;
  if(pos('%HAVEFINAL%',Result)>0) then begin
    if(geo.HaveFinal) then Result:=ReplaceString(Result,'%HAVEFINAL%','true')
    else                   Result:=ReplaceString(Result,'%HAVEFINAL%','false');
  end;
  if(pos('%ISFOUND%',Result)>0) then begin
    if(geo.IsFound) then Result:=ReplaceString(Result,'%ISFOUND%','true')
    else                 Result:=ReplaceString(Result,'%ISFOUND%','false');
  end;
  if(pos('%ISOWNER%',Result)>0) then begin
    if(geo.IsOwner) then Result:=ReplaceString(Result,'%ISOWNER%','true')
    else                 Result:=ReplaceString(Result,'%ISOWNER%','false');
  end;
  if(pos('%HAVELISTING%',Result)>0) then begin
    if(geo.HaveListing) then
         Result:=ReplaceString(Result,'%HAVELISTING%','true')
    else Result:=ReplaceString(Result,'%HAVELISTING%','false');
  end;
  if(pos('%HAVEWAYPOINT%',Result)>0) then begin
    if(geo.HaveWaypoint) then
         Result:=ReplaceString(Result,'%HAVEWAYPOINT%','true')
    else Result:=ReplaceString(Result,'%HAVEWAYPOINT%','false');
  end;
  if(pos('%HAVELOG%',Result)>0) then begin
    Geoget_DB.AddParamText(':id',geo.ID);
    if (Geoget_DB.GetTableValue('SELECT count(key) FROM geolog WHERE id = :id;') > 0) then
         Result:=ReplaceString(Result,'%HAVELOG%','true')
    else Result:=ReplaceString(Result,'%HAVELOG%','false');
  end;
  if(pos('%HAVEATTACHMENT%',Result)>0) then begin
    if(geo.HaveAttachment) then Result:=ReplaceString(Result,'%HAVEATTACHMENT%','true')
    else                        Result:=ReplaceString(Result,'%HAVEATTACHMENT%','false');
  end;
  if(pos('%HAVERTFATTACHMENT%',Result)>0) then begin
    if(geo.HaveRTFAttachment) then Result:=ReplaceString(Result,'%HAVERTFATTACHMENT%','true')
    else                           Result:=ReplaceString(Result,'%HAVERTFATTACHMENT%','false');
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstWpt_SUBSTITUTIONS(wpt:TWpt;str:string) : String;
begin
  {$IFDEF profile} ProfileStart('VarSubstWpt_SUBSTITUTIONS'); {$ENDIF}
  Result := str;
  //Jednoduche nahrazeni
  if(pos('%WPTTYPE%',Result)>0) then              Result:=ReplaceString(Result,'%WPTTYPE%',wpt.WptType);
  if(pos('%WPTTYPEID%',Result)>0) then            Result:=ReplaceString(Result,'%WPTTYPEID%',wpt.TypeID);
  if(pos('%WPTID%',Result)>0) then                Result:=ReplaceString(Result,'%WPTID%',wpt.ID);
  if(pos('%WPTCOORDINATE%',Result)>0) then        Result:=ReplaceString(Result,'%WPTCOORDINATE%',FormatCoordNum(wpt.LatNum,wpt.LonNum));
  if(pos('%WPTLAT%',Result)>0) then               Result:=ReplaceString(Result,'%WPTLAT%',wpt.Lat);
  if(pos('%WPTLON%',Result)>0) then               Result:=ReplaceString(Result,'%WPTLON%',wpt.Lon);
  if(pos('%WPTNAME%',Result)>0) then              Result:=ReplaceString(Result,'%WPTNAME%',VarSubstEncode(wpt.Name));
  if(pos('%WPTCOMMENT%',Result)>0) then           Result:=ReplaceString(Result,'%WPTCOMMENT%',VarSubstEncode(wpt.Comment));
  if(pos('%WPTUPDATED%',Result)>0) then           Result:=ReplaceString(Result,'%WPTUPDATED%',VarSubst_DateToStr(wpt.Updated));
  if(pos('%WPTGUID%',Result)>0) then              Result:=ReplaceString(Result,'%WPTGUID%',wpt.GUID);
  if(pos('%WPTPREFIXID%',Result)>0) then          Result:=ReplaceString(Result,'%WPTPREFIXID%',wpt.PrefixID);
  if(pos('%WPTDESCRIPTION%',Result)>0) then       Result:=ReplaceString(Result,'%WPTDESCRIPTION%',VarSubstEncode(wpt.Description));
  
  //Logicke funkce
  if(pos('%WPTISUSERWAYPOINT%',Result)>0) then begin
    if(wpt.IsUserWaypoint) then                   Result:=ReplaceString(Result,'%WPTISUSERWAYPOINT%','true')
                           else                   Result:=ReplaceString(Result,'%WPTISUSERWAYPOINT%','false');
  end;
  if(pos('%WPTISFINAL%',Result)>0) then begin
    if(wpt.IsFinal)        then                   Result:=ReplaceString(Result,'%WPTISFINAL%','true')
                           else                   Result:=ReplaceString(Result,'%WPTISFINAL%','false');
  end;
  if(pos('%WPTISEMPTYCOORD%',Result)>0) then begin
    if(wpt.IsEmptyCoord)   then                   Result:=ReplaceString(Result,'%WPTISEMPTYCOORD%','true')
                           else                   Result:=ReplaceString(Result,'%WPTISEMPTYCOORD%','false');
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstGG_SUBSTITUTIONS(str:string) : String;
begin
  {$IFDEF profile} ProfileStart('VarSubstGG_SUBSTITUTIONS'); {$ENDIF}
  result := str;
  if(pos('%GGDATADIR%',Result)>0) then            Result:=ReplaceString(Result,'%GGDATADIR%',VarSubstEncode(GEOGET_Datadir));
  if(pos('%GGSCRIPTDIR%',Result)>0) then          Result:=ReplaceString(Result,'%GGSCRIPTDIR%',VarSubstEncode(GEOGET_Scriptdir));
  if(pos('%GGDBNAME%',Result)>0) then             Result:=ReplaceString(Result,'%GGDBNAME%',VarSubstEncode(GEOGET_DBname));
  if(pos('%GGVER%',Result)>0) then                Result:=ReplaceString(Result,'%GGVER%',VarSubstEncode(Geoget_Version));
  if(pos('%GGOWNER%',Result)>0) then              Result:=ReplaceString(Result,'%GGOWNER%',VarSubstEncode(Geoget_Owner));
  if(pos('%CRLF%',Result)>0) then                 Result:=ReplaceString(Result,'%CRLF%',VARSUBST_CRLF);
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_FUNCTIONS(str:string;var err:integer):string;
begin
  {$IFDEF profile} ProfileStart('VarSubst_FUNCTIONS'); {$ENDIF}
    //chyby pri zpracovani funkci se nikam nehlasi, mozna nekdy priste ...
    //(mohlo by toho byt opravdu hodne, pro kazdou kes, ...)
    Result:=VarSubst_RecurseFunc(Result,'%REPLACE(');
    Result:=VarSubst_TAG(Result,err);
    Result:=VarSubst_IFTAG(Result,err);
    err:=0; while (err=0) do Result:=VarSubst_FUNCTIONS_1PAR(Result,'%ROT13(',err);
    err:=0; while (err=0) do Result:=VarSubst_FUNCTIONS_1PAR(Result,'%REVERSE(',err);
    Result:=VarSubst_RecurseFunc(Result,'%IF(');
    Result:=VarSubst_RecurseFunc(Result,'%REPLACEFULL(');
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstGeo_OWNFUNCTION(geo:TGeo;str:string;bBefore : boolean):string;
var i:Integer;
    fceG:VarSubstGeo_TypeFuncReplace;
begin
  {$IFDEF profile} ProfileStart('VarSubstGeo_OWNFUNCTION'); {$ENDIF}
  Result:=str;
  for i:=0 to VarSubstGeo_ReplaceFuncN-1 do begin
    if((VarSubstGeo_ReplaceFuncArr[i].bBefore=bBefore)) then 
    begin
        fceG:=VarSubstGeo_ReplaceFuncArr[i].fFunkce;
        Result:=fceG(geo,Result);
    end;
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstWpt_OWNFUNCTION(wpt:TWpt;str:string;bBefore : boolean):string;
var i:Integer;
    fceW:VarSubstWpt_TypeFuncReplace;
begin
  {$IFDEF profile} ProfileStart('VarSubstWpt_OWNFUNCTION'); {$ENDIF}
  Result:=str;
  for i:=0 to VarSubstWpt_ReplaceFuncN-1 do begin
    if((VarSubstWpt_ReplaceFuncArr[i].bBefore=bBefore)) then 
    begin
        fceW:=VarSubstWpt_ReplaceFuncArr[i].fFunkce;
        Result:=fceW(wpt,Result);
    end;
  end;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstWpt(wpt:TWpt;input:string; bAnsi:boolean; var output:string): boolean;
var err:integer;
begin
  {$IFDEF profile} ProfileStart('VarSubstWpt'); {$ENDIF}
  Result:=true;
  output:=VarSubst_DeleteComment(input)+'&end&';  //pridame neco na konec, aby na konci nebylo %
  VarSubst_Geo:=wpt.parentGeo;
  VarSubst_bAnsi:=bAnsi;

  //zbavime se CRLF, ktere nabourava rozeznavani parametru pri zpracovani funkci
  //nevolat VarSubstEncode, nahradi i uvozovky
  output:=ReplaceString(output,CRLF,VARSUBST_CRLF);
  output := VarSubstWpt_OWNFUNCTION(wpt, output, true);
  output := VarSubstGG_SUBSTITUTIONS(output);
  output := VarSubstGeo_SUBSTITUTIONS(VarSubst_Geo,output);
  output := VarSubstWpt_SUBSTITUTIONS(wpt,output);

  //------------- obsluha funkci ---------------
  //nahradime procenta, aby nestrasila pri dalsim zpracovani
  //teoreticky by se zde mohlo vyskytnou %JMENO%%JMENO%, proto to udelame co nejpozdeji
  //ted by nemel text obsahovat zadny znak % krome oznaceni a ohraniceni funkci
  //vsechny testy je treba provadet opakovane, dokud tam jeste nejake jsou
  output := VarSubst_FUNCTIONS(output,err);
  output := VarSubstWpt_OWNFUNCTION(wpt, output, false);

  if(pos('%LISTING%',output)>0) then              output:=ReplaceString(output,'%LISTING%',VarSubstEncode(varsubst_geo.ShortDescription+VARSUBST_CRLF+varsubst_geo.LongDescription));
  if(pos('%LONGLISTING%',output)>0) then          output:=ReplaceString(output,'%LONGLISTING%',VarSubstEncode(varsubst_geo.LongDescription));
  if(pos('%SHORTLISTING%',output)>0)then          output:=ReplaceString(output,'%SHORTLISTING%',VarSubstEncode(varsubst_geo.ShortDescription));

  //do vystupu vratime puvodni procenta, uvozovky, CRLF, ...
  if(bAnsi) then output:=UtfToAnsi(VarSubst_Decode(output))
  else output:=VarSubst_Decode(output);
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstGeo(geo:TGeo;input:string; bAnsi:boolean; var output:string): boolean;
var err:integer;
begin
  {$IFDEF profile} ProfileStart('VarSubstGeo'); {$ENDIF}
  Result:=true;
  output:=VarSubst_DeleteComment(input)+'&end&';  //pridame neco na konec, aby na konci nebylo %
  VarSubst_Geo:=geo;
  VarSubst_bAnsi:=bAnsi;

  //zbavime se CRLF, ktere nabourava rozeznavani parametru pri zpracovani funkci
  //nevolat VarSubstEncode, nahradi i uvozovky
  output:=ReplaceString(output,CRLF,VARSUBST_CRLF);
  output := VarSubstGeo_OWNFUNCTION(geo, output, true);
  output := VarSubstGG_SUBSTITUTIONS(output);
  output := VarSubstGeo_SUBSTITUTIONS(geo,output);

  //------------- obsluha funkci ---------------
  //nahradime procenta, aby nestrasila pri dalsim zpracovani
  //teoreticky by se zde mohlo vyskytnou %JMENO%%JMENO%, proto to udelame co nejpozdeji
  //ted by nemel text obsahovat zadny znak % krome oznaceni a ohraniceni funkci
  //vsechny testy je treba provadet opakovane, dokud tam jeste nejake jsou
  output := VarSubst_FUNCTIONS(output,err);
  output := VarSubstGeo_OWNFUNCTION(geo,output,false);

  if(pos('%LISTING%',output)>0) then              output:=ReplaceString(output,'%LISTING%',VarSubstEncode(geo.ShortDescription+VARSUBST_CRLF+geo.LongDescription));
  if(pos('%LONGLISTING%',output)>0) then          output:=ReplaceString(output,'%LONGLISTING%',VarSubstEncode(geo.LongDescription));
  if(pos('%SHORTLISTING%',output)>0)then          output:=ReplaceString(output,'%SHORTLISTING%',VarSubstEncode(geo.ShortDescription));

  //do vystupu vratime puvodni procenta, uvozovky, CRLF, ...
  if(bAnsi) then output:=UtfToAnsi(VarSubst_Decode(output))
  else output:=VarSubst_Decode(output);
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

// --------------------- uzivatelem definovane funkce pro nahradu
function VarSubstGeo_FindReplaceFunction(fce:VarSubstGeo_TypeFuncReplace):Integer;
var i:Integer;
begin
  {$IFDEF profile} ProfileStart('VarSubstGeo_FindReplaceFunction'); {$ENDIF}
  Result:=-1;
  for i:=0 to VarSubstGeo_ReplaceFuncN do
    if(VarSubstGeo_ReplaceFuncArr[i].fFunkce=fce) then Result:=i;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubstWpt_FindReplaceFunction(fce:VarSubstWpt_TypeFuncReplace):Integer;
var i:Integer;
begin
  {$IFDEF profile} ProfileStart('VarSubstWpt_FindReplaceFunction'); {$ENDIF}
  Result:=-1;
  for i:=0 to VarSubstWpt_ReplaceFuncN do
    if(VarSubstWpt_ReplaceFuncArr[i].fFunkce=fce) then Result:=i;
  {$IFDEF profile} ProfileStop; {$ENDIF}
end;

function VarSubst_ComboAdd(aText:Tstrings):string;
var s:string;
    i:integer;
begin
  Result:='';
  //kontrola, zda obsahuje popisny text, pokud ne, doplnime ho
  for i:=0 to aText.Count-1 do begin
    if(pos(VARSUBST_VZOR_SEPARATE,aText[i])<1) then s:=aText[i]+VARSUBST_VZOR_SEPARATE+_('??? (bez popisu)')
    else s:=aText[i];
    Result:=Result+s+CRLF;
    //ale do comboboxu to pridamejen jednou
    if(VarSubstForm_ComboSeznam.Items.IndexOf(s)<0) then
      VarSubstForm_ComboSeznam.Items.Add(s);
  end;
  Result:=trim(Result);
end;

procedure VarSubst_ComboDel(text:string);
var i,j:integer;
    s,s1:string;
begin
  s:=text;
  while(s<>'') do begin   //vsechny substringy
    s1:=fetch(s,CRLF);
    i:=0;
    //zjistimne, kolikrat se popisech vyskytuje promenna nebo funkce
    for j:=0 to VarSubstGeo_ReplaceFuncN do begin
      if(pos(CRLF+s1+CRLF,CRLF+VarSubstGeo_ReplaceFuncArr[j].sVzor+CRLF)>0) then i:=i+1;
    end;
    for j:=0 to VarSubstWpt_ReplaceFuncN do begin
      if(pos(CRLF+s1+CRLF,CRLF+VarSubstWpt_ReplaceFuncArr[j].sVzor+CRLF)>0) then i:=i+1;
    end;
    if(i=1) then begin //vymazeme pokud je jen 1x
      i:=VarSubstForm_ComboSeznam.Items.IndexOf(s1);
      if(i>-1) then VarSubstForm_ComboSeznam.Items.Delete(i);
    end;
  end;
end;

function VarSubstAddFunctionReplaceGeo(fce:VarSubstGeo_TypeFuncReplace;aVzor:TStrings;bBefore:boolean):boolean;
begin
  if(VarSubst_sInit<>VARSUBST_ISINIT) then VarSubst_Init();
  Result:=false;
  if(VarSubstGeo_FindReplaceFunction(fce)=-1) then begin
    if(VarSubstGeo_ReplaceFuncN+1>VARSUBST_MAXFUNC) then begin
      ShowMessage(_('Pekroen poet uivatelskch funkc'));
    end
    else begin
      if(aVzor=nil) or (fce=nil) then
        ShowMessage(_('Chybn parametry pro registraci funkce'))
      else begin
        VarSubstGeo_ReplaceFuncArr[VarSubstGeo_ReplaceFuncN].fFunkce:=fce;
        VarSubstGeo_ReplaceFuncArr[VarSubstGeo_ReplaceFuncN].sVzor:=VarSubst_ComboAdd(aVzor);
        VarSubstGeo_ReplaceFuncArr[VarSubstGeo_ReplaceFuncN].bBefore:=bBefore;
        VarSubstGeo_ReplaceFuncN:=VarSubstGeo_ReplaceFuncN+1;
        Result:=true;
      end;
    end;
  end
  else ShowMessage(_('Duplicitn registrace funkce - ignorovno.'));
end;

function VarSubstAddFunctionReplaceWpt(fce:VarSubstWpt_TypeFuncReplace;aVzor:TStrings;bBefore:boolean):boolean;
begin
  if(VarSubst_sInit<>VARSUBST_ISINIT) then VarSubst_Init();
  Result:=false;
  if(VarSubstWpt_FindReplaceFunction(fce)=-1) then begin
    if(VarSubstWpt_ReplaceFuncN+1>VARSUBST_MAXFUNC) then begin
      ShowMessage(_('Pekroen poet uivatelskch funkc'));
    end
    else begin
      if(aVzor=nil) or (fce=nil) then
        ShowMessage(_('Chybn parametry pro registraci funkce'))
      else begin
        VarSubstWpt_ReplaceFuncArr[VarSubstWpt_ReplaceFuncN].fFunkce:=fce;
        VarSubstWpt_ReplaceFuncArr[VarSubstGeo_ReplaceFuncN].sVzor:=VarSubst_ComboAdd(aVzor);
        VarSubstWpt_ReplaceFuncArr[VarSubstWpt_ReplaceFuncN].bBefore:=bBefore;
        VarSubstWpt_ReplaceFuncN:=VarSubstWpt_ReplaceFuncN+1;
        Result:=true;
      end;
    end;
  end
  else ShowMessage(_('Duplicitn registrace funkce - ignorovno.'));
end;

function VarSubstDelFunctionReplaceGeo(fce:VarSubstGeo_TypeFuncReplace):boolean;
var i,j:Integer;
begin
  if(VarSubst_sInit<>VARSUBST_ISINIT) then VarSubst_Init();
  Result:=false;
  i:=VarSubstGeo_FindReplaceFunction(fce);
  if(i>-1) then begin
    //vyhledat registrovanou funkci v combo seznamu a vymazat ji
    VarSubst_ComboDel(VarSubstGeo_ReplaceFuncArr[i].sVzor);
    for j:=i to VarSubstGeo_ReplaceFuncN-1 do begin
      VarSubstGeo_ReplaceFuncArr[j]:=VarSubstGeo_ReplaceFuncArr[j+1];
    end;
    VarSubstGeo_ReplaceFuncN:=VarSubstGeo_ReplaceFuncN-1;
    Result:=true;
  end;
end;

function VarSubstDelFunctionReplaceWpt(fce:VarSubstWPt_TypeFuncReplace):boolean;
var i,j:Integer;
begin
  if(VarSubst_sInit<>VARSUBST_ISINIT) then VarSubst_Init();
  Result:=false;
  i:=VarSubstWpt_FindReplaceFunction(fce);
  if(i>-1) then begin
    //vyhledat registrovanou funkci v combo seznamu a vymazat ji
    VarSubst_ComboDel(VarSubstGeo_ReplaceFuncArr[i].sVzor);
    for j:=i to VarSubstWpt_ReplaceFuncN-1 do begin
      VarSubstWpt_ReplaceFuncArr[j]:=VarSubstWpt_ReplaceFuncArr[j+1];
    end;
    VarSubstWpt_ReplaceFuncN:=VarSubstWpt_ReplaceFuncN-1;
    Result:=true;
  end;
end;

// --------------------- obsluha testovaciho formulare
function VarSubst_TemplateFileToString(file : String) : String;
begin
    Result := '';
    if FileExists(file) then Result := FileToString(file);
end;

procedure VarSubst_ButDir(sender:TObject);
var sPath:string;
begin
  if(VarSubst_sLastDir='') then VarSubst_sLastDir:=GEOGET_DATADIR;
  if(OpenDlg(_('Vbr souboru s ablonou'),       //title
             VarSubst_sLastDir,                //InitDir
             'ofFileMustExist',                //options
             _('Vechny soubory') + ' (*.*)|*.*',      //filtr
             sPath)) then begin
    VarSubst_sLastTemplateFile := sPath;
    VarSubstForm_EditDir.Text:=sPath;
    VarSubst_sLastDir := RegexExtract('^.*\\',sPath);
    VarSubst_LoadTemplateToWindow(VarSubst_TemplateFileToString(sPath));
    VarSubstForm_EditResult.Text:='';
  end;
end;

procedure VarSubst_CheckTempl(sender:TObject);
begin
  if(VarSubstForm_CheckTempl.checked) then VarSubstForm_EditTemplate.ScrollBars:=ssVertical
  else VarSubstForm_EditTemplate.ScrollBars:=ssBoth;
end;

procedure VarSubst_CheckResult(sender:TObject);
begin
  if(VarSubstForm_CheckResult.checked) then VarSubstForm_EditResult.ScrollBars:=ssVertical
  else VarSubstForm_EditResult.ScrollBars:=ssBoth;
  if(VarSubst_bBrowser) then VarSubst_WriteHtml();
end;

procedure VarSubst_Resize(sender:TObject);
var x,y:integer;
begin
  x:=VarSubstForm.ClientWidth;
  y:=VarSubstForm.ClientHeight;
  if(x<700) then begin x:=700; VarSubstForm.ClientWidth:=x; end;
  if(y<440) then begin y:=440; VarSubstForm.ClientHeight:=y; end;
  if VarSubstForm_CheckShowResult.Checked then begin
     VarSubstForm_EditTemplate.Width:=(x-14)/2;
     VarSubstForm_EditResult.Visible := true;
     VarSubstForm_CheckResult.Visible := true;
     VarSubstForm_LabelVysledek.Visible := true;
  end else begin
     VarSubstForm_EditTemplate.Width:=(x-14);
     VarSubstForm_EditResult.Visible := false;
     VarSubstForm_CheckResult.Visible := false;
     VarSubstForm_LabelVysledek.Visible := false;
  end;
  VarSubstForm_EditTemplate.Height:=y-136-28;
  VarSubstForm_EditResult.Left:=3+(x/2);
  VarSubstForm_ButSaveAs.Left:=x-9-VarSubstForm_ButSaveAs.Width;
  VarSubstForm_ButSave.Left:=VarSubstForm_ButSaveAs.Left - VarSubstForm_ButSave.Width - 5;
  VarSubstForm_ButDir.Left:=VarSubstForm_ButSave.Left - VarSubstForm_ButDir.Width - 5;
  VarSubstForm_EditDir.Width:= VarSubstForm_ButDir.Left - VarSubstForm_EditDir.Left - 5;
  
  VarSubstForm_LabelVysledek.Left:= VarSubstForm_EditResult.Left;
  VarSubstForm_LabelDoc.Left:=x-9-VarSubstForm_LabelDoc.Width;
  VarSubstForm_CheckShowResult.Left:=x-9-VarSubstForm_CheckShowResult.Width;
  VarSubstForm_EditResult.Width:=VarSubstForm_EditTemplate.Width;
  VarSubstForm_EditResult.Height:=VarSubstForm_EditTemplate.Height+28;
  VarSubstForm_CheckTempl.Top:=y-39;
  VarSubstForm_CheckResult.Top:=y-39;
  VarSubstForm_CheckResult.Left:=x-9-VarSubstForm_CheckResult.Width;
  VarSubstForm_ButRefresh.Top:=y-39;
  VarSubstForm_ButRefresh.Left:=VarSubstForm_EditResult.Left-VarSubstForm_ButRefresh.Width-3;
  VarSubstForm_ButBrowser.Top:=VarSubstForm_ButRefresh.Top;
  VarSubstForm_ButBrowser.Left:=VarSubstForm_EditResult.Left+2;
  VarSubstForm_ButClose.Top:=VarSubstForm_ButRefresh.Top;
  VarSubstForm_ButClose.Left:=VarSubstForm_ButBrowser.Left+VarSubstForm_ButBrowser.Width+5;
  
  VarSubstForm_ComboSeznam.Top:=y-77;
  VarSubstForm_ComboSeznam.Width:=VarSubstForm_EditTemplate.Width-55;
  VarSubstForm_ButPaste.Top := VarSubstForm_ComboSeznam.Top;
  VarSubstForm_ButPaste.Height := VarSubstForm_ComboSeznam.Height;
  VarSubstForm_ButPaste.Left := VarSubstForm_ComboSeznam.Left + VarSubstForm_ComboSeznam.Width + 5;
  VarSubstForm_ButPaste.Width := VarSubstForm_EditTemplate.Width - VarSubstForm_ComboSeznam.Width - 8;  
end;

procedure VarSubst_CheckShowResult(sender:TObject);
begin
   VarSubst_Resize(sender);
end;

procedure VarSubst_ButRefresh(sender:TObject);
var g:Tgeo;
    w:TWpt;
    s,sTemplate:string;
begin
  sTemplate:=AnsiToUtf(VarSubstForm_EditTemplate.Text);
  if((sTemplate<>'') and (VarSubstForm_EditId.Text<>'')) then begin
    g:=TGeo.Create();
    g.LoadByGc(VarSubstForm_EditId.Text);
    if(g.id<>'') then VarSubstGeo(g,sTemplate,true,s)
    else begin
      w:=TWpt.Create();
      w.LoadByID(VarSubstForm_EditId.Text);
      VarSubstWpt(w,sTemplate,true,s);
      w.Free();
    end;
    g.Free();
  end
  else if (sender <> nil) then ShowMessage(_('Vyplte ID bodu a definujte ablonu.'));
  VarSubstForm_EditResult.Text:=s;
  //s:=RegexSubstitute('(.*)%IF\('+VARSUBST_REGVATA     //$1=vata
  //  +'"(.*?)"'+VARSUBST_REGVATA                           //$2=val1
  //  +'([<>=]{1,2})'+VARSUBST_REGVATA                    //$4=oper
  //  +'"(.*?)"'+VARSUBST_REGVATA+';'+VARSUBST_REGVATA      //$6=va2
  //  +'"(.*?)"'+VARSUBST_REGVATA+';'+VARSUBST_REGVATA    //$9=trueText
  //  +'"(.*?)"'+VARSUBST_REGVATA+'\)%'                   //$12=falseText
  //  +'(.*)$'                                            //$14=konec
  //  ,sTemplate
  //  ,'1. $1'+CRLF+'2. $2'+CRLF+'3. $3'+CRLF+'4. $4'+CRLF+'5. $5'+CRLF+'6. $6'+CRLF+'7. $7'+CRLF
  //   +'8. $8'+CRLF+'9. $9'+CRLF+'10. $10'+CRLF+'11. $11'+CRLF+'12. $12'+CRLF+'13. $13'+CRLF+'14. $14'+CRLF+'15. $15'
  //  );
  // VarSubstForm_EditResult.Text:=VarSubstForm_EditResult.Text+CRLF+CRLF+s;
  if(VarSubst_bBrowser) then VarSubst_WriteHtml();
end;

function VarSubstRandomGeoID : String;
var maxcount,rnd : integer;
begin
    maxcount := GEOGET_DB.GetTableValue('SELECT count(*) FROM geocache;');
    rnd := RandomRange(0,maxcount-1);
    GEOGET_DB.AddParamInt(':position',rnd);
    Result := GEOGET_DB.GetTableString('SELECT id FROM geocache LIMIT 1 OFFSET :position;');
end;

function VarSubstRandomWptID: String;
var maxcount,rnd : integer;
begin
    maxcount := GEOGET_DB.GetTableValue('SELECT count(*) FROM waypoint;');
    rnd := RandomRange(0,maxcount-1);
    GEOGET_DB.AddParamInt(':position',rnd);
    Result := GEOGET_DB.GetTableString('SELECT prefixid||SUBSTR(id,3) FROM waypoint LIMIT 1 OFFSET :position;');
end;

procedure VarSubst_ButRandPoint(sender:TObject);
begin
   VarSubstForm_EditId.Text := VarSubstRandomGeoID; 
end;

procedure VarSubst_ButRandWaypoint(sender:TObject);
begin
    VarSubstForm_EditId.Text := VarSubstRandomWptID;
end;
   
procedure VarSubst_LabelDoc(sender:TObject);
begin
   RunShell(VARSUBST_URL);
end;

procedure VarSubst_ButSave(sender:TObject);
begin
   StringToFile(VarSubstForm_EditTemplate.Text,VarSubst_sLastTemplateFile);
end;

procedure VarSubst_ButSaveAs(sender:TObject);
var sPath:string;
begin
  if(VarSubst_sLastDir='') then VarSubst_sLastDir:=GEOGET_DATADIR;
  sPath := VarSubst_sLastTemplateFile; 
  if(SaveDlg(_('Vbr souboru pro uloen'),      //title
             VarSubst_sLastDir,                //InitDir
             '',                               //options
             _('Vechny soubory') + ' (*.*)|*.*',      //filtr
             sPath)) then begin
    StringToFile(VarSubstForm_EditTemplate.Text,sPath); 
    VarSubst_sLastTemplateFile := sPath;
    VarSubstForm_EditDir.Text:=sPath;
    VarSubst_sLastDir := RegexExtract('^.*\\',sPath);
  end;
end;

function VarSubst_CanBeSavedToFile : boolean;
begin
  Result := FileExists(VarSubstForm_EditDir.Text) and (VarSubstForm_EditDir.Text = VarSubst_sLastTemplateFile);
end;

procedure VarSubst_EditDirChange(sender:TObject);
begin
  VarSubstForm_ButSave.Enabled := VarSubst_CanBeSavedToFile;
end;

procedure VarSubst_EditOnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if((Shift=[ssCtrl]) and (Key=65)) then (Sender as TMemo).SelectAll();
end;

procedure VarSubst_ButBrowserOnClick(sender:TObject);
begin
  VarSubst_bBrowser := true;
  VarSubst_ButRefresh(sender);
  RunShell(VarSubst_sHtml);
end;

procedure VarSubst_ButPasteOnClick(sender:TObject);
var s,s1:string;
begin
  s1:='';
  if(VarSubstForm_ComboSeznam.ItemIndex>-1) then begin
    s:=VarSubstForm_ComboSeznam.Items[VarSubstForm_ComboSeznam.ItemIndex];
    s1:=fetch(s,VARSUBST_VZOR_SEPARATE);
  end;
  if(copy(s1,1,1)='%') then begin //vkladat jen platne radky
    VarSubstForm_EditTemplate.SetFocus;
    VarSubstForm_EditTemplate.SelText := s1;
  end;
end;

procedure VarSubst_FormOnClose(Sender: TObject; var Action: TCloseAction);
begin
    if VarSubst_WasTemplateChanged() then begin
       case MessBox(_('ablona byla zmnna. Pejete si zmny uloit?'), _('Uloit zmny'),3) of
         6 : begin //Yes
               if VarSubst_bFileOperationsVisible then begin //sablona byla nactena ze souboru nebo z retezce
                  if VarSubst_CanBeSavedToFile 
                    then VarSubst_ButSave(Sender)
                    else VarSubst_ButSaveAs(Sender);
               end else begin //sablona je otevrena pouze v modu editace bez ukladani do souboru
                  VarSubst_sLoadedTemplate := VarSubstForm_EditTemplate.Text;
               end;
             end; 
         2 : begin //Cancel
                Action := caNone;
             end; 
         else begin end;
       end;
    end;
end;

procedure VarSubst_DlgInit(caption,id,sPathTemplate,startDir:string);
begin
  if(VarSubst_sInit<>VARSUBST_ISINIT) then VarSubst_Init();
  VarSubstForm_ComboSeznam.ItemIndex := 0;
  VarSubstForm.BorderStyle:=bsSizeable;
  VarSubstForm_ButRefresh.OnClick:=@VarSubst_ButRefresh;
  VarSubstForm_ButDir.OnClick:=@VarSubst_ButDir;
  VarSubstForm_ButSave.OnClick:=@VarSubst_ButSave;
  VarSubstForm_ButSaveAs.OnClick:=@VarSubst_ButSaveAs;
  VarSubstForm_ButRandPoint.OnClick:=@VarSubst_ButRandPoint;
  VarSubstForm_ButRandWaypoint.OnClick:=@VarSubst_ButRandWaypoint;
  VarSubstForm_LabelDoc.OnClick:=@VarSubst_LabelDoc;
  VarSubstForm_EditDir.OnChange:=@VarSubst_EditDirChange;
  VarSubstForm_CheckTempl.OnClick:=@VarSubst_CheckTempl;
  VarSubstForm_CheckResult.OnClick:=@VarSubst_CheckResult;
  VarSubstForm_CheckShowResult.OnClick:=@VarSubst_CheckShowResult;
  VarSubstForm.OnResize:=@VarSubst_Resize;
  VarSubstForm_EditTemplate.OnKeyDown:=@VarSubst_EditOnKeyDown;
  VarSubstForm_EditResult.OnKeyDown:=@VarSubst_EditOnKeyDown;
  VarSubstForm_ButBrowser.OnClick:=@VarSubst_ButBrowserOnClick;
  VarSubstForm_ButPaste.OnClick:=@VarSubst_ButPasteOnClick;
  VarSubstForm.OnClose:=@VarSubst_FormOnClose;

  VarSubstForm_EditDir.Text:=sPathTemplate;
  VarSubst_sLastTemplateFile := sPathTemplate;
  VarSubstForm_EditId.Text:=id;
  VarSubstForm_EditResult.Text:='';
  if caption <> '' then VarSubstForm.Caption := caption;
  if DirectoryExists(startDir) then VarSubst_sLastDir := startDir;
  VarSubst_Resize(VarSubstForm);
end;

procedure VarSubst_SetFileOperationsVisible(visible : boolean);
begin
   VarSubst_bFileOperationsVisible := visible;
   VarSubstForm_Label1.Visible := VarSubst_bFileOperationsVisible;
   VarSubstForm_EditDir.Visible := VarSubst_bFileOperationsVisible;
   VarSubstForm_ButDir.Visible := VarSubst_bFileOperationsVisible;
   VarSubstForm_ButSave.Visible := VarSubst_bFileOperationsVisible;
   VarSubstForm_ButSaveAs.Visible := VarSubst_bFileOperationsVisible;
end;
procedure VarSubstDlgTemplateString(caption,id,sTemplate,startDir:string);
begin
  VarSubst_DlgInit(caption,id,'',startDir);
  VarSubst_SetFileOperationsVisible(true);
  VarSubst_LoadTemplateToWindow(UtfToAnsi(sTemplate));
  VarSubst_ButRefresh(nil);
  VarSubstForm.Showmodal();
end;

procedure VarSubstDlgTemplateFile(caption,id,sPathTemplate,startDir:string);
begin
  VarSubst_DlgInit(caption,id,sPathTemplate,startDir);
  VarSubst_SetFileOperationsVisible(true);
  VarSubst_LoadTemplateToWindow(UtfToAnsi(VarSubst_TemplateFileToString(sPathTemplate)));
  VarSubst_ButRefresh(nil);
  VarSubstForm.Showmodal();
end;

function VarSubstDlgTemplateStringNoSave(caption,id,sTemplate: string) : String;
begin 
  Result := '';
  VarSubst_DlgInit(caption,id,'','');
  VarSubst_SetFileOperationsVisible(false);
  VarSubst_LoadTemplateToWindow(UtfToAnsi(sTemplate));
  VarSubst_ButRefresh(nil);
  VarSubstForm.Showmodal();
  Result := VarSubst_sLoadedTemplate;  //Obsah dosazovane promenne je rizen VarSubst_FormOnClose eventem
end;

//end.